#!/usr/local/bin/perl
# ----------------------------------------------------------------------
#
# 【RSStoMixi】RSS1.0 をパースし、Mixi へ最新駄文を自動投稿
#
# Update:2011/03/18
#
# Copyright (c) 2011 by JJWorkshop HIRO. <http://jjworkshop.com/>
# ----------------------------------------------------------------------

use XML::Simple;
use LWP::UserAgent;
use lib qw(/home/..../web/cgi-bin/mixpost);
use WWW::Mixi;
use Data::Dumper;
use Jcode;
use utf8;

# ----------------------------------------------------------------------
# 各種設定
# ----------------------------------------------------------------------

# RSS1.0 のファイルパス（フルパスでね！）
$rssPath  = "/home/..../web/index.rdf";

# 最終更新日保存ファイル（これは予め空で存在しないとダメよ）
$datePath = "/home/..../web/cgi-hoge/mixpost/date.dat";

#Mixi の設定
$mixi_email    = 'メールアドレスね！';
$mixi_password = 'パスワードね！';

# ----------------------------------------------------------------------
# 処理
# ----------------------------------------------------------------------

$mixi = WWW::Mixi->new($mixi_email, $mixi_password);

# XML データを読み込みパース
$xs = new XML::Simple(forcearray => 1, keyattr => []);
$xml = $xs->XMLin($rssPath);
#print Dumper $xml;


# 最終更新日を取得（ついでにロック）
$newDate = "";
open(IN,"<$datePath");
$lastDate = <IN>;
close(IN);
open(OUT,">$datePath");
flock(OUT,2);

# RSSをスキャン
$cnt = 0;
while (defined($xml->{item}->[$cnt])) {$cnt++};
for ($cnt--; $cnt>=0; $cnt--) {
	$date  = $xml->{item}->[$cnt]->{'dc:date'}->[0];
	if ($lastDate lt $date)	{
		my $titl = $xml->{item}->[$cnt]->{title}->[0];
		my $body = $xml->{item}->[$cnt]->{description}->[0];
		my $link = $xml->{item}->[$cnt]->{link}->[0];
		
		&post_diary($titl,"$body\n《続きはこちら》\n　↓　↓\n$link\n\nJJworkshop BLOG auto post system by JJ.");
		$newDate = $date;
		last;
	}
}

# 最終更新日更新
if ($newDate eq "")	{$newDate = $lastDate};
print OUT $date;
close(OUT);
exit;


# Mixi へポスト
#日記の投稿
sub post_diary{
	my ($title, $body) =@_;
	$title = Jcode->new($title,'utf8')->euc;
	$body = Jcode->new($body,'utf8')->euc;
	my %diary = (
		'diary_title' => $title,
		'diary_body' => $body,
	);
	#ログインの確認
	$mixi->login unless ($mixi->is_logined);
	my $result = $mixi->get_add_diary_confirm(%diary);
	print "Result = $result\n";
}